Package com.complexible.stardog.search

# Class SearchOptions

java.lang.Object
com.complexible.stardog.search.SearchOptions

All Implemented Interfaces:
  `MetaPropertyProvider`

public final class SearchOptions extends Object implements MetaPropertyProvider

Database options for the waldo search index.

Since:
  1.2
Version:
  6.0
Author:
  Michael Grove

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `static final String`
  `DEFAULT_VECTOR_MODEL`
  `static final ConfigProperty<Boolean>`
  `INDEX_COMPUTE_NORM`
  `static final ConfigProperty<Collection<IRI>>`
  `INDEX_DATATYPES`
  Option to specify the datatypes for which to index literals.
  `static final ConfigProperty<Collection<IRI>>`
  `INDEX_PROPERTIES_EXCLUDED`
  Option to specify the properties to be excluded for literals to be indexed.
  `static final ConfigProperty<Collection<IRI>>`
  `INDEX_PROPERTIES_INCLUDED`
  Option to specify the only properties for literals to be indexed.
  `static final ConfigProperty<Collection<String>>`
  `INDEX_STOPWORDS`
  Option to specify the stopwords for which to filter terms while indexing terms.
  `static final ConfigProperty<Collection<String>>`
  `INDEX_TOKEN_FILTERS`
  `static final ConfigProperty<Double>`
  `LABEL_RELATIVE_THRESHOLD`
  `static final ConfigProperty<Boolean>`
  `LEADING_WILDCARD_SEARCH_ENABLED`
  Option to enable the Lucene query parser's support of leading wildcards in queries as shown here.
  `static final ConfigProperty<Boolean>`
  `OPTIMIZE`
  `static final String`
  `PROPERTY_DEFAULT_QUERY_OPERATOR`
  `static final String`
  `PROPERTY_INDEX_COMPUTE_NORM`
  `static final String`
  `PROPERTY_INDEX_DATATYPE`
  `static final String`
  `PROPERTY_INDEX_PROPERTIES_EXCLUDED`
  `static final String`
  `PROPERTY_INDEX_PROPERTIES_INCLUDED`
  `static final String`
  `PROPERTY_INDEX_STOPWORDS`
  `static final String`
  `PROPERTY_LEADING_WILDCARD_SEARCH_ENABLED`
  `static final String`
  `PROPERTY_OPTIMIZE`
  `static final String`
  `PROPERTY_REINDEX_CACHE_SIZE`
  `static final String`
  `PROPERTY_SEARCH_CONTEXTS_EXCLUDED`
  `static final String`
  `PROPERTY_SEARCH_CONTEXTS_FILTER`
  `static final String`
  `PROPERTY_SEARCH_INDEX_BATCH_SIZE`
  `static final String`
  `PROPERTY_SEARCH_INDEX_STATE`
  `static final String`
  `PROPERTY_SEARCH_LEXICAL`
  `static final String`
  `PROPERTY_SEARCH_PAGE_SIZE`
  `static final String`
  `PROPERTY_SEARCH_SEMANTIC_CONTEXTS_FILTER`
  `static final String`
  `PROPERTY_SEARCH_SEMANTIC_ENABLED`
  `static final String`
  `PROPERTY_SEARCH_SEMANTIC_MODEL`
  `static final String`
  `PROPERTY_TOKEN_FILTERS`
  `static final String`
  `PROPERTY_USE_VACUUMING`
  `static final String`
  `PROPERTY_WORD_BREAK_CHARS`
  `static final ConfigProperty<Integer>`
  `REINDEX_CACHE_SIZE`
  Option to specify the cache size of literals that is used for seeing if a literal is reindexed before.
  `static final ConfigProperty<Double>`
  `RELATIVE_THRESHOLD`
  `static final ConfigProperty<Boolean>`
  `SEARCH_CONTEXTS_EXCLUDED`
  Option to specify if `SEARCH_CONTEXTS_FILTER`, the collection of contexts in named graphs, is going to be leveraged as either excluded or included for literals to be indexed.
  `static final ConfigProperty<Collection<IRI>>`
  `SEARCH_CONTEXTS_FILTER`
  Option to specify the collection of contexts in named graphs to be excluded or included for literals to be indexed depending on `SEARCH_CONTEXTS_EXCLUDED` option: By default `SEARCH_CONTEXTS_EXCLUDED` is set to `true`, meaning this set is to be leveraged as an exclusion list.
  `static final ConfigProperty<Integer>`
  `SEARCH_DEFAULT_LIMIT`
  Deprecated.
  `static final ConfigProperty<String>`
  `SEARCH_DEFAULT_QUERY_OPERATOR`
  `static final ConfigProperty<Integer>`
  `SEARCH_INDEX_BATCH_SIZE`
  `static final ConfigProperty<Boolean>`
  `SEARCH_INDEX_DIRTY`
  Deprecated.
  `static final ConfigProperty<com.complexible.stardog.search.SearchIndexState>`
  `SEARCH_INDEX_STATE`
  State of the search index, see `SearchIndexState`
  `static final ConfigProperty<Boolean>`
  `SEARCH_LEXICAL`
  `static final ConfigProperty<Integer>`
  `SEARCH_PAGE_SIZE`
  Specify the page size used for iteration over results from the full-text index.
  `static final ConfigProperty<Boolean>`
  `SEARCH_REINDEX_IN_TX`
  Flag to indicate if the search index should be updated as part of update transactions.
  `static final ConfigProperty<Boolean>`
  `SEARCH_SEMANTIC`
  `static final ConfigProperty<Collection<IRI>>`
  `SEARCH_SEMANTIC_CONTEXTS_FILTER`
  `static final ConfigProperty<String>`
  `SEARCH_SEMANTIC_MODEL`
  `static final ConfigProperty<Boolean>`
  `SEARCHABLE`
  Option for whether or not full-text search via Waldo is enabled for the database
  `static final ConfigProperty<Boolean>`
  `USE_VACUUMING`
  `static final ConfigProperty<String>`
  `WORD_BREAK_CHARS`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `SearchOptions()`

- ## Method Summary

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Field Details

  - ### PROPERTY_SEARCH_INDEX_STATE

    public static final String PROPERTY_SEARCH_INDEX_STATE
    See Also:
      - Constant Field Values

  - ### PROPERTY_SEARCH_SEMANTIC_MODEL

    public static final String PROPERTY_SEARCH_SEMANTIC_MODEL
    See Also:
      - Constant Field Values

  - ### PROPERTY_SEARCH_SEMANTIC_ENABLED

    public static final String PROPERTY_SEARCH_SEMANTIC_ENABLED
    See Also:
      - Constant Field Values

  - ### PROPERTY_SEARCH_LEXICAL

    public static final String PROPERTY_SEARCH_LEXICAL
    See Also:
      - Constant Field Values

  - ### PROPERTY_LEADING_WILDCARD_SEARCH_ENABLED

    public static final String PROPERTY_LEADING_WILDCARD_SEARCH_ENABLED
    See Also:
      - Constant Field Values

  - ### PROPERTY_SEARCH_PAGE_SIZE

    public static final String PROPERTY_SEARCH_PAGE_SIZE
    See Also:
      - Constant Field Values

  - ### PROPERTY_DEFAULT_QUERY_OPERATOR

    public static final String PROPERTY_DEFAULT_QUERY_OPERATOR
    See Also:
      - Constant Field Values

  - ### PROPERTY_INDEX_DATATYPE

    public static final String PROPERTY_INDEX_DATATYPE
    See Also:
      - Constant Field Values

  - ### PROPERTY_WORD_BREAK_CHARS

    public static final String PROPERTY_WORD_BREAK_CHARS
    See Also:
      - Constant Field Values

  - ### PROPERTY_INDEX_STOPWORDS

    public static final String PROPERTY_INDEX_STOPWORDS
    See Also:
      - Constant Field Values

  - ### PROPERTY_TOKEN_FILTERS

    public static final String PROPERTY_TOKEN_FILTERS
    See Also:
      - Constant Field Values

  - ### PROPERTY_INDEX_PROPERTIES_EXCLUDED

    public static final String PROPERTY_INDEX_PROPERTIES_EXCLUDED
    See Also:
      - Constant Field Values

  - ### PROPERTY_SEARCH_CONTEXTS_FILTER

    public static final String PROPERTY_SEARCH_CONTEXTS_FILTER
    See Also:
      - Constant Field Values

  - ### PROPERTY_SEARCH_CONTEXTS_EXCLUDED

    public static final String PROPERTY_SEARCH_CONTEXTS_EXCLUDED
    See Also:
      - Constant Field Values

  - ### PROPERTY_SEARCH_SEMANTIC_CONTEXTS_FILTER

    public static final String PROPERTY_SEARCH_SEMANTIC_CONTEXTS_FILTER
    See Also:
      - Constant Field Values

  - ### PROPERTY_INDEX_PROPERTIES_INCLUDED

    public static final String PROPERTY_INDEX_PROPERTIES_INCLUDED
    See Also:
      - Constant Field Values

  - ### PROPERTY_INDEX_COMPUTE_NORM

    public static final String PROPERTY_INDEX_COMPUTE_NORM
    See Also:
      - Constant Field Values

  - ### PROPERTY_OPTIMIZE

    public static final String PROPERTY_OPTIMIZE
    See Also:
      - Constant Field Values

  - ### PROPERTY_USE_VACUUMING

    public static final String PROPERTY_USE_VACUUMING
    See Also:
      - Constant Field Values

  - ### PROPERTY_REINDEX_CACHE_SIZE

    public static final String PROPERTY_REINDEX_CACHE_SIZE
    See Also:
      - Constant Field Values

  - ### PROPERTY_SEARCH_INDEX_BATCH_SIZE

    public static final String PROPERTY_SEARCH_INDEX_BATCH_SIZE
    See Also:
      - Constant Field Values

  - ### DEFAULT_VECTOR_MODEL

    public static final String DEFAULT_VECTOR_MODEL
    See Also:
      - Constant Field Values

  - ### SEARCH_INDEX_DIRTY

    @Deprecated public static final ConfigProperty<Boolean> SEARCH_INDEX_DIRTY
    Deprecated.

  - ### SEARCH_INDEX_STATE

    public static final ConfigProperty<com.complexible.stardog.search.SearchIndexState> SEARCH_INDEX_STATE

    State of the search index, see `SearchIndexState`

    Full name: search.index.state
    Default value: `SearchIndexState.Dirty`

  - ### SEARCH_REINDEX_IN_TX

    public static final ConfigProperty<Boolean> SEARCH_REINDEX_IN_TX

    Flag to indicate if the search index should be updated as part of update transactions. If this flag is set to `false` and search queries will return incomplete results until search index is rebuilt.

    Full name: search.reindex.tx
    Default value: `true`

  - ### SEARCHABLE

    public static final ConfigProperty<Boolean> SEARCHABLE
    Option for whether or not full-text search via Waldo is enabled for the database

  - ### SEARCH_LEXICAL

    public static final ConfigProperty<Boolean> SEARCH_LEXICAL

  - ### SEARCH_SEMANTIC

    public static final ConfigProperty<Boolean> SEARCH_SEMANTIC

  - ### SEARCH_SEMANTIC_MODEL

    public static final ConfigProperty<String> SEARCH_SEMANTIC_MODEL

  - ### LEADING_WILDCARD_SEARCH_ENABLED

    public static final ConfigProperty<Boolean> LEADING_WILDCARD_SEARCH_ENABLED

    Option to enable the Lucene query parser's support of leading wildcards in queries as shown here. This option should be used with care because leading wildcard searches are not very efficient.

    Full name: leading.wildcard.search.enabled
    Default value: `false`

  - ### SEARCH_PAGE_SIZE

    public static final ConfigProperty<Integer> SEARCH_PAGE_SIZE
    Specify the page size used for iteration over results from the full-text index. A page is held in memory, so this count should NOT be large.

    Full name: search.page.size
    Default value: `100`

  - ### SEARCH_DEFAULT_LIMIT

    @Deprecated public static final ConfigProperty<Integer> SEARCH_DEFAULT_LIMIT
    Deprecated.
    Default max number of results from a lucene search, can be overridden in the search

    Full name: search.default.limit
    Default value: `-1` (all results)

  - ### RELATIVE_THRESHOLD

    public static final ConfigProperty<Double> RELATIVE_THRESHOLD

  - ### LABEL_RELATIVE_THRESHOLD

    public static final ConfigProperty<Double> LABEL_RELATIVE_THRESHOLD

  - ### SEARCH_DEFAULT_QUERY_OPERATOR

    public static final ConfigProperty<String> SEARCH_DEFAULT_QUERY_OPERATOR

  - ### INDEX_PROPERTIES_EXCLUDED

    public static final ConfigProperty<Collection<IRI>> INDEX_PROPERTIES_EXCLUDED
    Option to specify the properties to be excluded for literals to be indexed. Default value is an empty HashSet, could be populated with IRIs using the same constructor. Full name: "search.index.properties.excluded"

  - ### INDEX_PROPERTIES_INCLUDED

    public static final ConfigProperty<Collection<IRI>> INDEX_PROPERTIES_INCLUDED
    Option to specify the only properties for literals to be indexed. Default value is an empty HashSet, could be populated with IRIs using the same constructor. Please note that if `INDEX_PROPERTIES_EXCLUDED` option is set, this option will have no effect. Full name: "search.index.properties.included"

  - ### SEARCH_CONTEXTS_FILTER

    public static final ConfigProperty<Collection<IRI>> SEARCH_CONTEXTS_FILTER
    Option to specify the collection of contexts in named graphs to be excluded or included for literals to be indexed depending on `SEARCH_CONTEXTS_EXCLUDED` option: By default `SEARCH_CONTEXTS_EXCLUDED` is set to `true`, meaning this set is to be leveraged as an exclusion list. Otherwise, which is the case that option is set to `false`, the set is to be an inclusive one. Default value is an empty collection, could be populated with IRIs using the same constructor. Full name: "search.index.contexts.filter"

  - ### SEARCH_CONTEXTS_EXCLUDED

    public static final ConfigProperty<Boolean> SEARCH_CONTEXTS_EXCLUDED
    Option to specify if `SEARCH_CONTEXTS_FILTER`, the collection of contexts in named graphs, is going to be leveraged as either excluded or included for literals to be indexed. Default value: `true` Full name: "search.index.contexts.excluded"

  - ### SEARCH_SEMANTIC_CONTEXTS_FILTER

    public static final ConfigProperty<Collection<IRI>> SEARCH_SEMANTIC_CONTEXTS_FILTER

  - ### INDEX_DATATYPES

    public static final ConfigProperty<Collection<IRI>> INDEX_DATATYPES
    Option to specify the datatypes for which to index literals.

  - ### INDEX_COMPUTE_NORM

    public static final ConfigProperty<Boolean> INDEX_COMPUTE_NORM

  - ### OPTIMIZE

    public static final ConfigProperty<Boolean> OPTIMIZE

  - ### USE_VACUUMING

    public static final ConfigProperty<Boolean> USE_VACUUMING

  - ### WORD_BREAK_CHARS

    public static final ConfigProperty<String> WORD_BREAK_CHARS

  - ### INDEX_STOPWORDS

    public static final ConfigProperty<Collection<String>> INDEX_STOPWORDS
    Option to specify the stopwords for which to filter terms while indexing terms. The default value is `null`, which is leveraged as Lucene's ENGLISH_STOP_WORDS_SET For customization, a list of string should be assigned, e.g. Arrays.asList("a", "an")

  - ### INDEX_TOKEN_FILTERS

    public static final ConfigProperty<Collection<String>> INDEX_TOKEN_FILTERS

  - ### REINDEX_CACHE_SIZE

    public static final ConfigProperty<Integer> REINDEX_CACHE_SIZE
    Option to specify the cache size of literals that is used for seeing if a literal is reindexed before. Full name: "search.reindex.cache.size"

  - ### SEARCH_INDEX_BATCH_SIZE

    public static final ConfigProperty<Integer> SEARCH_INDEX_BATCH_SIZE

- ## Constructor Details

  - ### SearchOptions

    public SearchOptions()